# AbcWarmStart Class Reference

As CoinWarmStartBasis but with alternatives (Also uses Clp status meaning for slacks). More...

`#include <AbcWarmStart.hpp>`

Inheritance diagram for AbcWarmStart:
[legend]
Collaboration diagram for AbcWarmStart:
[legend]

List of all members.

## Public Member Functions
Methods to modify the warm start object
virtual void | setSize (int ns, int na)
| Set basis capacity; existing basis is discarded.
virtual void | resize (int newNumberRows, int newNumberColumns)
| Set basis capacity; existing basis is maintained.
virtual void | compressRows (int tgtCnt, const int *tgts)
| Delete a set of rows from the basis.
virtual void | deleteRows (int rawTgtCnt, const int *rawTgts)
| Delete a set of rows from the basis.
virtual void | deleteColumns (int number, const int *which)
| Delete a set of columns from the basis.
void | setModel (AbcSimplex *model)
| Set model.
AbcSimplex * | model () const
| Get model.
void | createBasis0 (const AbcSimplex *model)
| Create Basis type 0.
void | createBasis12 (const AbcSimplex *model)
| Create Basis type 12.
void | createBasis34 (const AbcSimplex *model)
| Create Basis type 34.
Constructors, destructors, and related functions
| AbcWarmStart ()
| Default constructor.
| AbcWarmStart (AbcSimplex *model, int type)
| Constructs a warm start object with the specified status vectors.
| AbcWarmStart (const AbcWarmStart &ws)
| Copy constructor.
virtual CoinWarmStart * | clone () const
| `Virtual constructor'
virtual | ~AbcWarmStart ()
| Destructor.
virtual AbcWarmStart & | operator= (const AbcWarmStart &rhs)
| Assignment.
virtual void | assignBasisStatus (int ns, int na, char *&sStat, char *&aStat)
| Assign the status vectors to be the warm start information.
## Protected Attributes
Protected data members
int | typeExtraInformation_
| Type of basis (always status arrays) 0 - as CoinWarmStartBasis 1,2 - plus factor order as shorts or ints (top bit set means column) 3,4 - plus compact saved factorization add 8 to say steepest edge weights stored (as floats) may want to change next,previous to tree info so can use a different basis for weights.
int | lengthExtraInformation_
| Length of extra information in bytes.
char * | extraInformation_
| The extra information.
AbcSimplex * | model_
| Pointer back to AbcSimplex (can only be applied to that).
AbcWarmStartOrganizer * | organizer_
| Pointer back to AbcWarmStartOrganizer for organization.
AbcWarmStart * | previousBasis_
| Pointer to previous basis.
AbcWarmStart * | nextBasis_
| Pointer to next basis.
int | stamp_
| Sequence stamp for deletion.
int | numberValidRows_
| Number of valid rows (rest should have slacks) Check to see if weights are OK for these rows and then just btran new ones for weights.

## Detailed Description

As CoinWarmStartBasis but with alternatives (Also uses Clp status meaning for slacks).

Definition at line 75 of file AbcWarmStart.hpp.

## Constructor & Destructor Documentation

AbcWarmStart::AbcWarmStart | ( |  | ) |

Default constructor.

Creates a warm start object representing an empty basis (0 rows, 0 columns).

AbcWarmStart::AbcWarmStart | ( | AbcSimplex * | model,
|  | int | type |
| ) |  |  |

Constructs a warm start object with the specified status vectors.

The parameters are copied. Consider assignBasisStatus(int,int,char*&,char*&) if the object should assume ownership.

See also:
  AbcWarmStart::Status for a description of the packing used in the status arrays.

AbcWarmStart::AbcWarmStart | ( | const AbcWarmStart & | ws | ) |

Copy constructor.

virtual AbcWarmStart::~AbcWarmStart | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void AbcWarmStart::setSize | ( | int | ns,
|  | int | na |
| ) |  |  | `[virtual]`

Set basis capacity; existing basis is discarded.

After execution of this routine, the warm start object does not describe a valid basis: all structural and artificial variables have status isFree.

Reimplemented from CoinWarmStartBasis.

virtual void AbcWarmStart::resize | ( | int | newNumberRows,
|  | int | newNumberColumns |
| ) |  |  | `[virtual]`

Set basis capacity; existing basis is maintained.

After execution of this routine, the warm start object describes a valid basis: the status of new structural variables (added columns) is set to nonbasic at lower bound, and the status of new artificial variables (added rows) is set to basic. (The basis can be invalid if new structural variables do not have a finite lower bound.)

Reimplemented from CoinWarmStartBasis.

virtual void AbcWarmStart::compressRows | ( | int | tgtCnt,
|  | const int * | tgts |
| ) |  |  | `[virtual]`

Delete a set of rows from the basis.

Warning:
  This routine assumes that the set of indices to be deleted is sorted in ascending order and contains no duplicates. Use deleteRows() if this is not the case.
  The resulting basis is guaranteed valid only if all deleted constraints are slack (hence the associated logicals are basic).

Removal of a tight constraint with a nonbasic logical implies that some basic variable must be made nonbasic. This correction is left to the client.

Reimplemented from CoinWarmStartBasis.

virtual void AbcWarmStart::deleteRows | ( | int | rawTgtCnt,
|  | const int * | rawTgts |
| ) |  |  | `[virtual]`

Delete a set of rows from the basis.

Warning:
  The resulting basis is guaranteed valid only if all deleted constraints are slack (hence the associated logicals are basic).

Removal of a tight constraint with a nonbasic logical implies that some basic variable must be made nonbasic. This correction is left to the client.

Reimplemented from CoinWarmStartBasis.

virtual void AbcWarmStart::deleteColumns | ( | int | number,
|  | const int * | which |
| ) |  |  | `[virtual]`

Delete a set of columns from the basis.

Warning:
  The resulting basis is guaranteed valid only if all deleted variables are nonbasic.

Removal of a basic variable implies that some nonbasic variable must be made basic. This correction is left to the client.

Reimplemented from CoinWarmStartBasis.

void AbcWarmStart::setModel | ( | AbcSimplex * | model | ) | `[inline]`

Set model.

Definition at line 140 of file AbcWarmStart.hpp.

AbcSimplex* AbcWarmStart::model | ( |  | ) | const`[inline]`

Get model.

Definition at line 143 of file AbcWarmStart.hpp.

void AbcWarmStart::createBasis0 | ( | const AbcSimplex * | model | ) |

Create Basis type 0.

void AbcWarmStart::createBasis12 | ( | const AbcSimplex * | model | ) |

Create Basis type 12.

void AbcWarmStart::createBasis34 | ( | const AbcSimplex * | model | ) |

Create Basis type 34.

virtual CoinWarmStart* AbcWarmStart::clone | ( |  | ) | const`[inline, virtual]`

`Virtual constructor'

Reimplemented from CoinWarmStartBasis.

Definition at line 177 of file AbcWarmStart.hpp.

virtual AbcWarmStart& AbcWarmStart::operator= | ( | const AbcWarmStart & | rhs | ) | `[virtual]`

Assignment.

Reimplemented from CoinWarmStartBasis.

virtual void AbcWarmStart::assignBasisStatus | ( | int | ns,
|  | int | na,
|  | char *& | sStat,
|  | char *& | aStat |
| ) |  |  | `[virtual]`

Assign the status vectors to be the warm start information.

In this method the AbcWarmStart object assumes ownership of the pointers and upon return the argument pointers will be NULL. If copying is desirable, use the array constructor or the assignment operator .

Note:
  The pointers passed to this method will be freed using delete[], so they must be created using new[].

Reimplemented from CoinWarmStartBasis.

## Member Data Documentation

int AbcWarmStart::typeExtraInformation_`[protected]`

Type of basis (always status arrays) 0 - as CoinWarmStartBasis 1,2 - plus factor order as shorts or ints (top bit set means column) 3,4 - plus compact saved factorization add 8 to say steepest edge weights stored (as floats) may want to change next,previous to tree info so can use a different basis for weights.

Definition at line 218 of file AbcWarmStart.hpp.

int AbcWarmStart::lengthExtraInformation_`[protected]`

Length of extra information in bytes.

Definition at line 220 of file AbcWarmStart.hpp.

char* AbcWarmStart::extraInformation_`[protected]`

The extra information.

Definition at line 222 of file AbcWarmStart.hpp.

AbcSimplex* AbcWarmStart::model_`[protected]`

Pointer back to AbcSimplex (can only be applied to that).

Definition at line 224 of file AbcWarmStart.hpp.

AbcWarmStartOrganizer* AbcWarmStart::organizer_`[protected]`

Pointer back to AbcWarmStartOrganizer for organization.

Definition at line 226 of file AbcWarmStart.hpp.

AbcWarmStart* AbcWarmStart::previousBasis_`[protected]`

Pointer to previous basis.

Definition at line 228 of file AbcWarmStart.hpp.

AbcWarmStart* AbcWarmStart::nextBasis_`[protected]`

Pointer to next basis.

Definition at line 230 of file AbcWarmStart.hpp.

int AbcWarmStart::stamp_`[protected]`

Sequence stamp for deletion.

Definition at line 232 of file AbcWarmStart.hpp.

int AbcWarmStart::numberValidRows_`[protected]`

Number of valid rows (rest should have slacks) Check to see if weights are OK for these rows and then just btran new ones for weights.

Definition at line 237 of file AbcWarmStart.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Clp-1.15.11/Clp/src/AbcWarmStart.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines